%define         rc_subver     rc5

Summary:        ASCII art library
Name:           aalib
Version:        1.4.0
Release:        0.1.%{rc_subver}
License:        LGPLv2+
Group:          System Environment/Libraries
URL:            http://aa-project.sourceforge.net/aalib/
Source0:        http://download.sourceforge.net/aa-project/%{name}-1.4%{rc_subver}.tar.gz
Patch0:         %{name}-1.4rc5-ltconfig.patch
Patch1:         %{name}-1.4rc5-aix.patch
Patch2:         %{name}-aclocal.patch
Patch3:         %{name}-1.4rc5-bug149361.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

BuildRequires:  patch
Requires:       %{name}-libs = %{version}-%{release}

%description
AA-lib is a low level gfx library just as many other libraries are. The
main difference is that AA-lib does not require graphics device. In
fact, there is no graphical output possible. AA-lib replaces those
old-fashioned output methods with a powerful ASCII art renderer. The API
is designed to be similar to other graphics libraries.

The library is available as 32-bit and 64-bit.


%package libs
Summary:        Library files for %{name}
Group:          System/Libraries
Obsoletes:	%{name} < 1.4.0-0.1

%description libs
This package contains library files for aalib.


%package devel
Summary:        Development files for %{name}
Group:          Development/Libraries
Requires:       %{name}-libs = %{version}-%{release}
Requires:       /sbin/install-info, info

%description devel
This package contains header files and other files needed to develop
with aalib.

If you are compiling a 32-bit program, no special compiler options are
needed.

If you are compiling a 64-bit program, you have to compile and link your
application with "cc -q64" or "gcc -maix64".


%prep
export PATH=/opt/freeware/bin:$PATH
%setup -q
%patch0
%patch1
%patch2 -p0
%patch3 -p1 -b .bug149361


%build
# setup environment for 32-bit and 64-bit builds
export AR="ar -X32_64"
export NM="nm -X32_64"

# first build the 64-bit version
export CC="cc -q64"
./configure \
    --prefix=%{_prefix} \
    --enable-shared --disable-static
make %{?_smp_mflags}

cp ./src/.libs/libaa.so.1.0.4 .
make distclean

# now build the 32-bit version
export CC="cc"
./configure \
    --prefix=%{_prefix} \
    --enable-shared --disable-static
make %{?_smp_mflags}

# create 32-bit shared library
rm -f ./src/.libs/libaa.a
${AR} -rv ./src/.libs/libaa.a ./src/.libs/libaa.so.1.0.4

# add the 64-bit shared objects to the shared library containing already the
# 32-bit shared objects
${AR} -q ./src/.libs/libaa.a ./libaa.so.1.0.4

cp ./src/.libs/libaa.a .


%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}
make DESTDIR=${RPM_BUILD_ROOT} install

/usr/bin/strip ${RPM_BUILD_ROOT}%{_bindir}/* || :

cp ${RPM_BUILD_ROOT}%{_libdir}/libaa.la .
rm -f ${RPM_BUILD_ROOT}%{_libdir}/*
cp ./libaa.a ${RPM_BUILD_ROOT}%{_libdir}/
chmod 0644 ${RPM_BUILD_ROOT}%{_libdir}/libaa.a
cat ./libaa.la | sed 's|libaa.so.1.0.4 libaa.so.1 ||' > ${RPM_BUILD_ROOT}%{_libdir}/libaa.la
chmod 0755 ${RPM_BUILD_ROOT}%{_libdir}/libaa.la

rm -f ${RPM_BUILD_ROOT}%{_infodir}/dir
gzip --best ${RPM_BUILD_ROOT}%{_infodir}/*info*

(
  cd ${RPM_BUILD_ROOT}
  for dir in bin include lib
  do
    mkdir -p usr/$dir
    cd usr/$dir
    ln -sf ../..%{_prefix}/$dir/* .
    cd -
  done
)


%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%post devel
/sbin/install-info %{_infodir}/%{name}.info.gz %{_infodir}/dir 2>/dev/null || :


%preun devel
if [ $1 -eq 0 ]; then
    /sbin/install-info --delete %{_infodir}/%{name}.info.gz %{_infodir}/dir \
    2>/dev/null || :
fi


%files
%defattr(-,root,system,-)
%{_bindir}/aafire
%{_bindir}/aainfo
%{_bindir}/aasavefont
%{_bindir}/aatest
%{_mandir}/man1/aafire.1*
/usr/bin/aafire
/usr/bin/aainfo
/usr/bin/aasavefont
/usr/bin/aatest


%files libs
%defattr(-,root,system,-)
%doc README COPYING ChangeLog NEWS
%{_libdir}/*.a
/usr/lib/*.a


%files devel
%defattr(-,root,system,-)
%{_bindir}/aalib-config
%{_includedir}/*
%{_libdir}/*.la
%{_mandir}/man3/*
%{_infodir}/%{name}.info*
%{_datadir}/aclocal/%{name}.m4
/usr/bin/%{name}-config
/usr/include/*
/usr/lib/*.la


%changelog
* Fri Aug 29 2008 Michael Perzl <michael@perzl.org> - 1.4.0-0.1.rc5
- first version for AIX V5.1 and higher
